function select_sig
%========================================================================

%Copyright (c) 1999-2000 The University of Texas
%All Rights Reserved.
 
%This program is free software; you can redistribute it and/or modify
%it under the terms of the GNU General Public License as published by
%the Free Software Foundation; either version 2 of the License, or
%(at your option) any later version.
 
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.
 
%The GNU Public License is available in the file LICENSE, or you
%can write to the Free Software Foundation, Inc., 59 Temple Place -
%Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
%World Wide Web at http://www.fsf.org.

 %Demo ideas : Dr.Alan C Bovik
 %Programmer :	Umesh Rajashekar 
 %Version:        %W%	%G%

%The authors are with the Department of Electrical and Computer
%Engineering, The University of Texas at Austin, Austin, TX.
%They can be reached at bovik@ece.utexas.edu and umesh@ece.utexas.edu

%Kindly report any suggestions or corrections to the demos to 
%umesh@ece.utexas.edu

%========================================================================
%function selects the signal to be interpolated
figure(2);

pop_hndl = findobj(gcbf,'Tag','pop_select');
val = get(pop_hndl,'Value');
names = get(pop_hndl,'String');

type = names{val};

sig_freq = 1;	%signal is 1 HZ
num_periods = 2;

%upto 2 secs=> 2 periods and 40 samples per period
samp_hndl = findobj(gcbf,'Tag','slider_samp');
samp = floor(get(samp_hndl,'Value'));

t_max = 3;
N = 199;
time = linspace(0,t_max,N);
samp_time = linspace(0,t_max,floor(N/samp));


switch type,
case 'Sine'
   act_sig = sin(2*pi*sig_freq*time);
   samp_sig = sin(2*pi*sig_freq*samp_time);
   
   
case 'Sawtooth'
   act_sig = sawtooth(2*pi*sig_freq*time);
   samp_sig =sawtooth(2*pi*sig_freq*samp_time);
   
case 'Triangular'
   act_sig = sawtooth(2*pi*sig_freq*time,0.5);
   samp_sig =sawtooth(2*pi*sig_freq*samp_time,0.5);
   
case 'Square'
   act_sig = square(2*pi*sig_freq*time);
   samp_sig = square(2*pi*sig_freq*samp_time);

end

%plot the signal
plot(time,act_sig,'r--');
hold on;
plot(samp_time,samp_sig,'ko');
%hold off;


%find the sort of plotting to be done
%====================================


%figure(3);

interp_hndl = findobj(gcbf,'Tag','pop_interp');
val = get(interp_hndl,'Value');
names = get(interp_hndl,'String');
type = names{val};

switch type,
case('ZOH')
   %interp_sig = repmat(samp_sig,99,1);
   %interp_sig = reshape(interp_sig,prod(size(interp_sig)),1);
   %interp_sig(end:-1:end-98)=[];%no need to replicate the last few samples
   %my_time = linspace(0,t_max,length(interp_sig));
   %plot(my_time,interp_sig);
   %hold off;
   stairs(samp_time,samp_sig);


   
case('Linear')
   plot(samp_time,samp_sig);
   

case('Cubic')
   samp_sig = interp1(samp_time,samp_sig,time,'cubic');
   plot(time,samp_sig);

end  
hold off;

   %zoom on;
legend('Original','Samples','Reconstructed');

